//	Global Variables
var muted = true;
var appMute = false;
var iTunesMute = false;
var tickTock = preferences.playTickTockPref.value;
var displayScale = preferences.scalePref.value;
var commStart = false;
var showSeconds = false;
var widgetURL = "http://widgets.hpearth.com";
var verboseUpdate = false;

if(system.platform == "windows")
	var helperPath = 'Grandfather_Clock_Helper';
else
	var helperPath = resolvePath('.') + '/Resources/Grandfather_Clock_Helper.widget';


//	Get & Store default image properties
_mainWindow = new image(0,0,mainWindow.width,mainWindow.height);
_background1 = new image(background1.hOffset,background1.vOffset,background1.width,background1.height);
_background2 = new image(background2.hOffset,background2.vOffset,background2.width,background2.height);
_border1 = new image(border1.hOffset,border1.vOffset,border1.width,border1.height);
_border2 = new image(border2.hOffset,border2.vOffset,border2.width,border2.height);
_border3 = new image(border3.hOffset,border3.vOffset,border3.width,border3.height);
_logo = new image(logo.hOffset,logo.vOffset,logo.width,logo.height);
_largeHashMarks = new image(largeHashMarks.hOffset,largeHashMarks.vOffset,largeHashMarks.width,largeHashMarks.height);
_smallHashMarks = new image(smallHashMarks.hOffset,smallHashMarks.vOffset,smallHashMarks.width,smallHashMarks.height);
_numbers1 = new image(numbers1.hOffset,numbers1.vOffset,numbers1.width,numbers1.height);
_numbers2 = new image(numbers2.hOffset,numbers2.vOffset,numbers2.width,numbers2.height);
_numbers3 = new image(numbers3.hOffset,numbers3.vOffset,numbers3.width,numbers3.height);
_windingHoles = new image(windingHoles.hOffset,windingHoles.vOffset,windingHoles.width,windingHoles.height);
_hourHand = new image(hourHand.hOffset,hourHand.vOffset,hourHand.width,hourHand.height,
                      hourHand.hRegistrationPoint,hourHand.vRegistrationPoint);
_minuteHand = new image(minuteHand.hOffset,minuteHand.vOffset,minuteHand.width,minuteHand.height,
                        minuteHand.hRegistrationPoint,minuteHand.vRegistrationPoint);
_secondHand = new image(secondHand.hOffset,secondHand.vOffset,secondHand.width,secondHand.height,
                        secondHand.hRegistrationPoint,secondHand.vRegistrationPoint);
_largeCenterButton = new image(largeCenterButton.hOffset,largeCenterButton.vOffset,largeCenterButton.width,largeCenterButton.height);
_smallCenterButton = new image(smallCenterButton.hOffset,smallCenterButton.vOffset,smallCenterButton.width,smallCenterButton.height);
_glass = new image(glass.hOffset,glass.vOffset,glass.width,glass.height);
_iTunesMutePref = preferences.iTunesMutePref.value;
_appMutePref = preferences.appMutePref.value;

function startup()
{
	log("widget startup - commStartTimer = "+preferences.commStartTimerPref.value * 5+" seconds");
	runCommand('open "Resources/Grandfather_Clock_Helper.widget"');
	updateSettings();
	resizeDisplay();
	updateTime();
	checkiTunes();
	checkApps();
	mainWindow.visible = 1;
	commStartTimer.ticking = true;
	if (preferences.checkForUpdatePref.value >=2)
		checkForUpdate();

}

function updateSettings()
{
	commStartTimer.interval = preferences.commStartTimerPref.value * 5;
	if ((preferences.optimizationPref.value == 1) && (preferences.showSecondsPref.value == 1))
	{
		// set preferences
		preferences.showSecondsPref.value = 1;
		preferences.showHashMarksPref.value = 1;
		preferences.showSecondsPref.value = 1;
		preferences.showHashMarksPref.value = 1;
		preferences.showWindingHolesPref.value = 1;
		preferences.showBackgroundPref.value = 1;
		preferences.showLogoPref.value = 1;
		preferences.showBorderPref.value = 2;
		preferences.showNumbersPref.value = 2;
		
		// set opacities
		largeHashMarks.opacity = 0;
		smallHashMarks.opacity = 0;
		windingHoles.opacity = 0;
		glass.opacity = preferences.showGlassPref.value * 127;
		logo.opacity = 0;
		secondHand.opacity = 255;
		smallCenterButton.opacity = 255;
		border1.opacity = 0;
		border2.opacity = 0;
		border3.opacity = 0;
		numbers1.opacity = 0;
		numbers2.opacity = 0;
		numbers3.opacity = 0;
		background1.opacity = 0;
		background2.opacity = 255;
	}
	else
	{
		smallCenterButton.opacity = preferences.showSecondsPref.value * 255;
		largeHashMarks.opacity = preferences.showHashMarksPref.value * 255;
		smallHashMarks.opacity = preferences.showSecondsPref.value * 255;
		smallHashMarks.opacity = preferences.showHashMarksPref.value * preferences.showSecondsPref.value * 255;
		windingHoles.opacity = preferences.showWindingHolesPref.value * 255;
		background1.opacity = preferences.showBackgroundPref.value * 255;
		secondHand.opacity = preferences.showSecondsPref.value * 255;
		glass.opacity = preferences.showGlassPref.value * 127;
		logo.opacity = preferences.showLogoPref.value * 255;
		background2.opacity = 0;
		setNumbers();
		setBorders();
	}
		
	// if display has been resized
	if (displayScale != preferences.scalePref.value)
		resizeDisplay();

	// if tick-tock preferences have been changed but not muted
	if ((tickTock != preferences.playTickTockPref.value) && (muteSounds == false) && (Number(preferences.playTickTockPref.value) > 0))
		muted = true;
		
	if ((preferences.checkForUpdatePref.value == 1)||(preferences.checkForUpdatePref.value == 3))
		checkForUpdateTimer.ticking = true;
	else
		checkForUpdateTimer.ticking = false;

	setiTunesAutoMute();
	setApplicationAutoMute();
	
}// end updateSettings()

function updateTime()
{
	time = new Date();
	hours = time.getHours();
	minutes = time.getMinutes();
	seconds = time.getSeconds();
	
	// check status of auto-mute scheduler
	checkMuteSchedule();
	
	// allow for time to play the westminster chime before muting
	if ((hours == preferences.stopSoundsPref.value) && (minutes == 0))
		allowMuteChimes();
		
	// allow for time to play the westminster chime before un-muting
	if ((minutes == 59) && (seconds >= 44) && (muteSounds == true))
		allowUnMuteChimes();
	
	// check for iTunes auto-mute status
	if (iTunesMute == true)
		muteSounds = true;

	// check for multi-media auto-mute status
	if (appMute == true)
		muteSounds = true;
	
	// play ticking sounds
	playTickTock();
	
	// westminster chimes code
	playWestminster();
	
	if (hours > 12)
		hours -= 12;

	hourHand.rotation = ((hours*30)+(minutes/2));
	minuteHand.rotation = ((minutes*6)+(seconds/10));
	if (preferences.showSecondsPref.value > 0)
		secondHand.rotation = seconds * 6;
}

function image(hOffset,vOffset,width,height,hRegistrationPoint,vRegistrationPoint)
{
	this.hOffset = hOffset;
	this.vOffset = vOffset;
	this.width   = width;
	this.height  = height;
	this.hRegistrationPoint = hRegistrationPoint;
	this.vRegistrationPoint = vRegistrationPoint;
}

function allowMuteChimes()
{
	if (hours == 0)
	{
		if (seconds < (preferences.playHourlyTollPref.value * 36))
			muteSounds = false;
	}
	else if (hours > 12)
	{	
		if (seconds < (preferences.playHourlyTollPref.value*3*(hours-12)))
			muteSounds = false;
	}
	else
	{	
		if (seconds < (preferences.playHourlyTollPref.value*3*hours))
			muteSounds = false;
	}
}

function allowUnMuteChimes()
{
	if (preferences.playWestminsterPref.value > 0)
	{
		if (hours == (preferences.startSoundsPref.value - 1))
		{
			muteSounds = false;
		}
		else if ((hours == 23) && (preferences.startSoundsPref.value == 0))
		{
			muteSounds = false;
		}
	}
}

function checkMuteSchedule()
{
	// if startSoundsPref comes earlier in the day than stopSoundsPref
	if (Number(preferences.startSoundsPref.value) < Number(preferences.stopSoundsPref.value))
	{
		if ((preferences.startSoundsPref.value <= hours) && (hours < preferences.stopSoundsPref.value))
		{
			muteSounds = false;
			if ((preferences.appMutePref.value == 1) && (appTimer.ticking == false))
			{
				appTimer.ticking = true;
			}
			if ((preferences.iTunesMutePref.value == 1) && (iTunesTimer.ticking == false))
			{
				iTunesTimer.ticking = true;
			}
		}
		else
		{
			muteSounds = true;
			if (appTimer.ticking == true)
			{
				appTimer.ticking = false;
			}
			if (iTunesTimer.ticking == true)
			{
				iTunesTimer.ticking = false;
			}
		}
	}
	else  // startSoundsPref comes later in the day than stopSoundsPref
	{
		if ((preferences.stopSoundsPref.value <= hours) && (hours < preferences.startSoundsPref.value))
		{
			muteSounds = true;
			if (appTimer.ticking == true)
			{
				appTimer.ticking = false;
			}
			if (iTunesTimer.ticking == true)
			{
				iTunesTimer.ticking = false;
			}
		}
		else
		{
			muteSounds = false;
			if ((preferences.appMutePref.value == 1) && (appTimer.ticking == false))
			{
				appTimer.ticking = true;
			}
			if ((preferences.iTunesMutePref.value == 1) && (iTunesTimer.ticking == false))
			{
				iTunesTimer.ticking = true;
			}
		}
	}
}

function setApplicationAutoMute()
{
	if (preferences.appMutePref.value == 1)
	{
		appTimer.interval = preferences.appTimerPref.value * 5;
		appTimer.ticking = true;
		// warning message for Windows users.
		if ((_appMutePref == 0) && (system.platform == "windows"))
		{
			var alertString = "Enabeling the 'multi-media automute' option may not work correctly "
			alertString += "if you are not using Windows XP"
			alert(alertString);
			_appMutePref = 1;
		}
	}
	else
	{
		appTimer.ticking = false;
		_appMutePref = 0;
	}
}

function setiTunesAutoMute()
{
	if (preferences.iTunesMutePref.value == 1)
	{
		iTunesTimer.interval = preferences.appTimerPref.value * 5;
		iTunesTimer.ticking = true;
		// notification message about iTunes message on iTunes exit
		if (_iTunesMutePref == 0)
		{
			var alertString = "Enabeling the 'iTunes automute' option may cause an alert that "
			alertString += "'One or more applications are using the iTunes scripting interface. "
			alertString += "Are you sure you want to Quit?'  when you exit iTunes.  However, "
			alertString += "this does not affect the operation of either program."
			alert(alertString);
			_iTunesMutePref = 1;
		}
	}
	else
	{
		iTunesTimer.ticking = false;
		_iTunesMutePref = 0;
	}
}

function setBorders()
{
	switch(Number(preferences.showBorderPref.value))
	{
		case 0:
			border1.opacity = 0;
			border2.opacity = 0;
			border3.opacity = 0;
			break;
		case 1:
			border1.opacity = 255;
			border2.opacity = 0;
			border3.opacity = 0;
			break;
		case 2:
			border1.opacity = 0;
			border2.opacity = 255;
			border3.opacity = 0;
			break;
		case 3:
			border1.opacity = 0;
			border2.opacity = 0;
			border3.opacity = 255;
			break;
	}
}

function setNumbers()
{
	switch(Number(preferences.showNumbersPref.value))
	{
		case 0:
			numbers1.opacity = 0;
			numbers2.opacity = 0;
			numbers3.opacity = 0;
			break;
		case 1:
			numbers1.opacity = 255;
			numbers2.opacity = 0;
			numbers3.opacity = 0;
			break;
		case 2:
			numbers1.opacity = 0;
			numbers2.opacity = 255;
			numbers3.opacity = 0;
			break;
		case 3:
			numbers1.opacity = 0;
			numbers2.opacity = 0;
			numbers3.opacity = 255;
			break;
	}
}

function speakTime()
{
	if (minutes == 0)
		speak(hours+"o clock");
	else if (minutes < 10)
		speak(hours+"o"+minutes);
	else
		speak(hours+" "+minutes);
}

function playTickTock()
{
	if (commStart == true)
	{
		// tickTock is playing, but preferences set to not play 
		if (((preferences.playTickTockPref.value == 0) || (muteSounds == true)) && (muted == false))
		{
			tellWidget(helperPath,"stopTickTock");
			log("tellWidget: stopTickTock");
			tickTock = 0;
			muted = true;
		}
		// tickTock preference is set to play
		if ((preferences.playTickTockPref.value > 0) && (muteSounds == false))
		{
			if ((muted == true) && (seconds%2 == 1))
			{
				sleep(800);
				if (preferences.playTickTockPref.value == 1)
				{
					tellWidget(helperPath,"startTickTockQuiet");
					log("tellWidget: startTickTockQuiet");
					tickTock = 1;
				}
				if (preferences.playTickTockPref.value == 2)
				{
					tellWidget(helperPath,"startTickTockNormal");
					log("tellWidget: startTickTockNormal");
					tickTock = 2;
				}
				muted = false;
			}
		}
	}
}

function playWestminster()
{
	if ((preferences.playWestminsterPref.value > 0) && (muteSounds == false))
	{
		if ((preferences.playWestminsterPref.value >= 1) && (minutes == 59) && (seconds == 44))
		{
			play("Resources/westminster60.wav", false);
			log("play westminster60.wav");
			if (preferences.playHourlyTollPref.value == 1)
			{
				startTollTimer.ticking = true;
			}
			muted = true; // pretend ticking is not playing to force re-sync with second hand
		}
		if ((preferences.playWestminsterPref.value >= 2) && (minutes == 30) && (seconds == 0))
		{
			play("Resources/westminster30.wav", false);
			log("play westminster30.wav");
			muted = true; // pretend ticking is not playing to force re-sync with second hand
		}
		if ((preferences.playWestminsterPref.value == 3) && (minutes == 15) && (seconds == 0))
		{
			play("Resources/westminster15.wav", false);
			log("play westminster15.wav");
			muted = true; // pretend ticking is not playing to force re-sync with second hand
		}
		if ((preferences.playWestminsterPref.value == 3) && (minutes == 45) && (seconds == 0))
		{
			play("Resources/westminster45.wav", false);
			log("play westminster45.wav");
			muted = true; // pretend ticking is not playing to force re-sync with second hand
		}
	} // end of westminster chime code
}

function resizeDisplay()
{
	displayScale = preferences.scalePref.value;
	scale = displayScale/20;

	log("resizeDisplay( "+scale+" )");
	
	mainWindow.width  = _mainWindow.width * scale;
	mainWindow.height = _mainWindow.height * scale;
	
	background1.hOffset = _background1.hOffset * scale;
	background1.vOffset = _background1.vOffset * scale;
	background1.width   = _background1.width * scale;
	background1.height  = _background1.height * scale;
	
	background2.hOffset = _background2.hOffset * scale;
	background2.vOffset = _background2.vOffset * scale;
	background2.width   = _background2.width * scale;
	background2.height  = _background2.height * scale;
	
	border1.hOffset = _border1.hOffset * scale;
	border1.vOffset = _border1.vOffset * scale;
	border1.width   = _border1.width * scale;
	border1.height  = _border1.height * scale;
	
	border2.hOffset = _border2.hOffset * scale;
	border2.vOffset = _border2.vOffset * scale;
	border2.width   = _border2.width * scale;
	border2.height  = _border2.height * scale;
	
	border3.hOffset = _border3.hOffset * scale;
	border3.vOffset = _border3.vOffset * scale;
	border3.width   = _border3.width * scale;
	border3.height  = _border3.height * scale;
	
	logo.hOffset = _logo.hOffset * scale;
	logo.vOffset = _logo.vOffset * scale;
	logo.width   = _logo.width  * scale;
	logo.height  = _logo.height * scale;

	largeHashMarks.hOffset = _largeHashMarks.hOffset * scale;
	largeHashMarks.vOffset = _largeHashMarks.vOffset * scale;
	largeHashMarks.width   = _largeHashMarks.width * scale;
	largeHashMarks.height  = _largeHashMarks.height * scale;

	smallHashMarks.hOffset = _smallHashMarks.hOffset * scale;
	smallHashMarks.vOffset = _smallHashMarks.vOffset * scale;
	smallHashMarks.width   = _smallHashMarks.width * scale;
	smallHashMarks.height  = _smallHashMarks.height * scale;

	numbers1.hOffset = _numbers1.hOffset * scale;
	numbers1.vOffset = _numbers1.vOffset * scale;
	numbers1.width   = _numbers1.width * scale;
	numbers1.height  = _numbers1.height * scale;

	numbers2.hOffset = _numbers2.hOffset * scale;
	numbers2.vOffset = _numbers2.vOffset * scale;
	numbers2.width   = _numbers2.width * scale;
	numbers2.height  = _numbers2.height * scale;

	numbers3.hOffset = _numbers3.hOffset * scale;
	numbers3.vOffset = _numbers3.vOffset * scale;
	numbers3.width   = _numbers3.width * scale;
	numbers3.height  = _numbers3.height * scale;

	windingHoles.hOffset = _windingHoles.hOffset * scale;
	windingHoles.vOffset = _windingHoles.vOffset * scale;
	windingHoles.width   = _windingHoles.width * scale;
	windingHoles.height  = _windingHoles.height * scale;

	hourHand.hOffset = _hourHand.hOffset * scale;
	hourHand.vOffset = _hourHand.vOffset * scale;
	hourHand.width   = _hourHand.width * scale;
	hourHand.height  = _hourHand.height * scale;
	hourHand.hRegistrationPoint = _hourHand.hRegistrationPoint * scale;
	hourHand.vRegistrationPoint = _hourHand.vRegistrationPoint * scale;

	minuteHand.hOffset = _minuteHand.hOffset * scale;
	minuteHand.vOffset = _minuteHand.vOffset * scale;
	minuteHand.width   = _minuteHand.width * scale;
	minuteHand.height  = _minuteHand.height * scale;
	minuteHand.hRegistrationPoint = _minuteHand.hRegistrationPoint * scale;
	minuteHand.vRegistrationPoint = _minuteHand.vRegistrationPoint * scale;

	secondHand.hOffset = _secondHand.hOffset * scale;
	secondHand.vOffset = _secondHand.vOffset * scale;
	secondHand.width   = _secondHand.width * scale;
	secondHand.height  = _secondHand.height * scale;
	secondHand.hRegistrationPoint = _secondHand.hRegistrationPoint * scale;
	secondHand.vRegistrationPoint = _secondHand.vRegistrationPoint * scale;

	largeCenterButton.hOffset = _largeCenterButton.hOffset * scale;
	largeCenterButton.vOffset = _largeCenterButton.vOffset * scale;
	largeCenterButton.width   = _largeCenterButton.width * scale;
	largeCenterButton.height  = _largeCenterButton.height * scale;

	smallCenterButton.hOffset = _smallCenterButton.hOffset * scale;
	smallCenterButton.vOffset = _smallCenterButton.vOffset * scale;
	smallCenterButton.width   = _smallCenterButton.width * scale;
	smallCenterButton.height  = _smallCenterButton.height * scale;

	glass.hOffset = _glass.hOffset * scale;
	glass.vOffset = _glass.vOffset * scale;
	glass.width   = _glass.width * scale;
	glass.height  = _glass.height * scale;
}

function startToll()
{
	startTollTimer.ticking = false;
	repeatTollTimer.ticking = true;
	play("Resources/toll.wav");
	log("play toll.wav");
	tollCount = 1;
}

function repeatToll()
{
	if (hours == 0)
		hours = 12;
		
	if (tollCount < hours)
	{
		play("Resources/toll.wav");
		log("play toll.wav");
	}
	else
	{
		repeatTollTimer.ticking = false;
	}

	tollCount++;
}

function checkiTunes()
{

	if (iTunes.running)
	{
		if (iTunes.playerStatus == "playing")
		{
			log("checkiTunes() = playing");
			iTunesMute = true;
		}
		else
		{
			log("checkiTunes() = running");
			iTunesMute = false;
		}
	}
	else
	{
		log("checkiTunes()");
		iTunesMute = false;
	}
}

function checkApps()
{
	if (system.platform == "windows")
		getProcsWin();
	else
		getProcsMac();
}

function getProcsWin()
{
	appMute = false;
	
	if (isApplicationRunning("QuickTimePlayer.exe"))
	{
		log("getProcsWin() = QuickTime");
		appMute = true;
	}
	else if (isApplicationRunning("wmplayer.exe"))
	{
		log("getProcsWin() = Windows Media Player");
		appMute = true;
	}
	else if (isApplicationRunning("winamp.exe"))
	{
		log("getProcsWin() = Winamp");
		appMute = true;
	}
	else
	{
		log("getProcsWin()");
	}
}

function getProcsMac()
{
	log("getProcsMac()");
	var script =  'tell application "System Events"\n';
	script += 'set procList to the name of every process\n';
	script += 'set res to ""\n';
	script += 'repeat with eachProc in procList\n';
	script += 'if res is not "" then set res to res & ","\n';
	script += 'set res to res & eachProc\n';
	script += 'end repeat\n';
	script += 'end tell\n';
	script += 'get res\n';

	var procList = appleScript(script, 20).split(",");

	appMute = false;
	
	for (var i in procList)
	{
		switch (procList[i])
		{
			case "QuickTime Player":
				var script =  'tell application "QuickTime Player"\n';
				script += 'set res to "QTP"\n';
				script += 'set movieList to every movie\n';
				script += 'repeat with eachMovie in movieList\n';
				script += 'set res to res & ";" & playing of eachMovie\n'; // playing  boolean
				script += 'end repeat\n';
				script += 'end tell\n';
				script += 'get res\n';
				var arrayQT = appleScript(script, 20).split(';');
				for (var i in arrayQT)
				{
					if (arrayQT[i] == "true")
						appMute = true; 
				}	
				break;
			case "RealPlayer":
				var script = 'tell application "RealPlayer"\n';
				script += 'set res to "RP"\n';
				script += 'set n to number of players\n';
				script += 'repeat with i from 1 to n\n';
				script += 'set res to res & ";" & state of player i\n'; // state string loading/paused/contacting/not loaded/stopped/playing
				script += 'end repeat\n';
				script += 'end tell\n';
				script += 'get res\n';
				var arrayRP = appleScript(script, 20).split(';');
				for (var i in arrayRP)
				{
					if(arrayRP[i] == "playing")
						appMute = true;
				}
				break;
			case "WindowsMediaPlayer":
				appMute = true;
				break;
		}
	}
}

function checkForUpdate()
{
	// use fetchAsync to get widget gallery page for posted version
	updating.hOffset = mainWindow.width / 2;
	updating.vOffset = (mainWindow.height / 2);
	updating.size = mainWindow.width / 10;
	updatingFlash();
	updatingTimer.ticking = true;
	var url = new URL();
	url.location = widgetURL;
	url.fetchAsync(compareVersions);
	
}

function compareVersions(url)
{
	updatingTimer.ticking = false;
	updating.opacity = 0;
	var beta = false;
	// process results from web gallery
	if (url.response != "200" ) // error retrieveing data
	{
		alert ("There was a problem contacting the Widget Gallery while checking for updates.");
	}
	else // data retreived without error
	{
		// set regExp search parameters
		var search = new RegExp( />Version \d+.\d+ - / );
		// search for version 
		var webResults = search.exec(url.result);
		search = new RegExp( /\d+.\d+/ );
		var webVersion = Number(search.exec(webResults));
		
		// get version information from the Grandfather Clock widget 
		var konFile = filesystem.readFile('Grandfather Clock.kon');
		var currentVersion = extractFrom(konFile, '<widget version="', '"');
		
		// check if currentVersion is a beta
		for (var i=0; i < currentVersion.length; i++)
		{
			if (currentVersion[i]=="b")
			{
				beta = true;
				currentVersion = currentVersion.substr(0,i);
			}
			
		}
		currentVersion = Number(currentVersion);
		if (beta == true)
		{
			print("Current Version: "+currentVersion+"beta");
			print("Web Version:     "+webVersion);
			if (webVersion >= currentVersion)
			{
				updateAvailable(currentVersion+"beta",webVersion);
			}
			else if (verboseUpdate == true)
			{
				alert("You have the most recent version of the Grandfather Clock Widget.");
			}
		}
		else
		{
			print("Current Version: "+currentVersion);
			print("Web Version:     "+webVersion);
			if (webVersion > currentVersion)
			{
				updateAvailable(currentVersion,webVersion);
			}
			else if (verboseUpdate == true)
			{
				alert("You have the most recent version of the Grandfather Clock Widget.");
			}
		}
	}
	verboseUpdate = false;
}

function updateAvailable(currentVersion,webVersion)
{
	var message = "There is a newer version of the Grandfather Clock Widget Available.  ";
	message += "You currently have "+currentVersion+" and "+webVersion+" is available.  ";
	message += "Would you like to visit the Widget Gallery to download the newer version?";
	var button1 = "Yes, lets go";
	var button2 = "No, not now";
	if (alert(message, button1, button2) == 1)
		openURL(widgetURL);
}


// thanks to g6auc (Harry) for this function
function extractFrom(data, prefix, suffix)
{
	function esc(s)
	{ 
		return s.replace(/([\W])/g,"\\$1"); 
	}
	
	var item = data.match(esc(prefix) + '([.\\s\\S]*?)' + esc(suffix));
	
	if (item !== null)
	{
		return item[1]; 
	}
	else
	{
		return "";
	}
}

function updatingFlash()
{
	if (updating.opacity == 0)
	{
		updating.opacity = 192;
		updating.bgOpacity = 192;
	}
	else
	{
		updating.opacity = 0;
		updating.bgOpacity = 0;
	}
}
